/**
	DisplayManager class
	JDG Communications for Federal Trade Commission
*/

//import com.gaiaframework.debug.*;

import mx.utils.Delegate;
import gs.TweenLite;
import gov.ftc.core.FunctionQueue;
import gov.ftc.core.Utilities;

import gov.ftc.squaresgame.GameBoardDisplay;
import gov.ftc.squaresgame.GameData;
import gov.ftc.squaresgame.QuestionDisplay;
import gov.ftc.squaresgame.GeneralScreenDisplay;

class gov.ftc.squaresgame.DisplayManager extends MovieClip {

// CLASS VARIABLES

	private var __gc:MovieClip;  // gameController
	private var __gd:GameData;
	private var __inited:Boolean;
	
	private var __functionQueue:FunctionQueue;
	
	private var __destroyList:Array;
	private var __currentScreen:MovieClip;

	public var gameBoard:GameBoardDisplay;
	public var gameIntro:GeneralScreenDisplay;
	public var hostScreen:GeneralScreenDisplay;
	public var question:QuestionDisplay;
	
	
// CONSTRUCTOR
	
	public function DisplayManager() {
		super();
		__inited = false;
		__gc = _global.squaresgameGC;
		__gd = _global.squaresgameGD.displayManager;
		init();
	}
	
// CLASS METHODS

	private function init():Void {
	
		if (!__inited) {
			__inited = true;
			__functionQueue = new FunctionQueue();
			
			Utilities.instantiateClassMc(this, "hostScreen", GeneralScreenDisplay, 410);
			hostScreen.init("hostScreen1");
			TweenLite.to(hostScreen, 0, {autoAlpha: 0});

			Utilities.instantiateClassMc(this, "gameBoard", GameBoardDisplay, 450);
			gameBoard.init();
			TweenLite.to(gameBoard, 0, {autoAlpha: 0});

			Utilities.instantiateClassMc(this, "gameIntro", GeneralScreenDisplay, 400);
			gameIntro.init("gameIntro", {_x: 320, _y:240});
			TweenLite.to(gameIntro, 0, {autoAlpha: 0});
			
			Utilities.instantiateClassMc(this, "question", QuestionDisplay, 470);
			
			__destroyList.push(gameBoard, hostScreen, gameIntro, question);
			
		}
	}
	
	public function displayScreen(p_screen:String):Void {
//		trace("displayManager.displayScreen: " + p_screen);
		var tweenVars:Object = {autoAlpha: 0, onCompleteParams: [p_screen]};
		if (p_screen.lastIndexOf("hostScreen") != -1) {
			tweenVars.onComplete = Delegate.create(this, setupHostScreen);
		} else {
			tweenVars.onComplete = Delegate.create(this, fadeInScreen);
		}
		if (__currentScreen != undefined) {
			TweenLite.to(__currentScreen, 0.5, tweenVars);
		} else {
			tweenVars.onComplete.apply(this, tweenVars.onCompleteParams);
		}
	}
	
	private function setupHostScreen(p_screen:String):Void {
//		trace("displayManager.setupHostScreen: " + p_screen);
		gameIntro.stop();
		hostScreen.init(p_screen);
		fadeInScreen("hostScreen");
	}
	
	private function fadeInScreen(p_screen:String):Void {
//		trace("displayManager.fadeInScreen: " + p_screen);
		__currentScreen = this[p_screen];
		var tweenVars:Object = {
			autoAlpha: 100,
			onComplete: Delegate.create(this, screenFadeDone),
			onCompleteParams: [p_screen]
		}
		TweenLite.to(__currentScreen, 0.5, tweenVars);
	}
	
	private function screenFadeDone(p_screen):Void {
//		trace("displayManager.screenFadeDone");
		__gc.gameBroadcaster.broadcastMessage("screenDisplayDoneEvent", p_screen);
	}
	
	
	public function destroy():Void {
//		trace("DisplayManager.destroy");
		var i:Number = this.__destroyList.length;
		while (i--) {
			__destroyList[i].stop();
			__destroyList[i].destroy();
		}
	}
}