/**
	GameBoardDisplay class
	JDG Communications for Federal Trade Commission
*/

import mx.utils.Delegate;

import gs.TweenLite;

import gov.ftc.core.Utilities;
import gov.ftc.core.FunctionDelay;

import gov.ftc.squaresgame.templates.DisplayClip;
import gov.ftc.squaresgame.Character;

class gov.ftc.squaresgame.GameBoardDisplay extends DisplayClip {

// CLASS VARIABLES
	private var __chars:Array;


// CONSTRUCTOR
	
	public function GameBoardDisplay() {
		super();
		setData("gameBoardDisplay");
	}
	
// CLASS METHODS

	public function init():Void {
		//called after setData() 
		super.init();
		
		mc = this.attachMovie("gameBoard","mc", 1);
		mc._x = 0;
		mc._y = 0;
		
		__chars = [];
		
		for (var i:Number=0; i<9; i++) {
			var c:Character = mc["character"+i];
			c.dim(false);
			c.mark();
			c.id = i;
			__chars.push(c);
		}
		
	}
	
	public function dimRest(p_mc:Character):Void {
//		trace("gameBoard.dimRest: " + p_mc._name);
		var i:Number = __chars.length;
		while (i--) {
			if (p_mc != __chars[i]) {
				__chars[i].dim(true);
			}
		}
	}
	
	public function undimAll():Void {
		var i:Number = __chars.length;
		while (i--) {
			__chars[i].dim(false);
		}
	}
	
	public function poseHost(p_label:String):Void {
		mc.host.pose(p_label);
	}
	
	public function showHostPrompt(p_label:String):Void {
		mc.host.showPrompt(p_label);
	}
	
	public function hideHostPrompt():Void {
		mc.host.hidePrompt();
	}
	
	public function showWin(p_array:Array, p_player:Number):Void {
		undimAll();
		var i:Number = p_array.length;
		while (i--) {
			if (p_array[i] == 1) __chars[i].flashBorder(true, p_player);
		}
		FunctionDelay.callDelayed(this, "endShowWin", __gd.showWinFlashDuration * 1000, null);
	}
	
	private function endShowWin():Void {
		var i:Number = __chars.length;
		while (i--) {
			__chars[i].flashBorder(false);
		}
		__gc.gameBroadcaster.broadcastMessage("winAnimationDoneEvent");
	}
	
	public function destroy():Void {
		this.onEnterFrame = null;
		TweenLite.killTweensOf(mc);
	}
	
}